Index: IMGUI/imgui.cpp
===================================================================
--- IMGUI/imgui.cpp	(revision c58ebc3899e898504313cf42b9c1c05170b13f8f)
+++ IMGUI/imgui.cpp	(revision e66fd66b98dfb2d3f0f1af0833f4b2957f60d166)
@@ -4017,510 +4195,207 @@
 void ImGui::EndFrame()
 {
-   ImGuiContext& g = *GImGui;
-   IM_ASSERT(g.Initialized);                       // Forgot to call ImGui::NewFrame()
-   if (g.FrameCountEnded == g.FrameCount)          // Don't process EndFrame() multiple times.
-      return;
-
-   // Notify OS when our Input Method Editor cursor has moved (e.g. CJK inputs using Microsoft IME)
-   if (g.IO.ImeSetInputScreenPosFn && ImLengthSqr(g.PlatformImeLastPos - g.PlatformImePos) > 0.0001f)
-   {
-      g.IO.ImeSetInputScreenPosFn((int)g.PlatformImePos.x, (int)g.PlatformImePos.y);
-      g.PlatformImeLastPos = g.PlatformImePos;
-   }
-
-   // Hide implicit "Debug" window if it hasn't been used
-   IM_ASSERT(g.CurrentWindowStack.Size == 1);    // Mismatched Begin()/End() calls
-   if (g.CurrentWindow && !g.CurrentWindow->WriteAccessed)
-      g.CurrentWindow->Active = false;
-   End();
-
-   if (g.ActiveId == 0 && g.HoveredId == 0)
-   {
-      if (!g.NavWindow || !g.NavWindow->Appearing) // Unless we just made a window/popup appear
-      {
-         // Click to focus window and start moving (after we're done with all our widgets)
-         if (g.IO.MouseClicked[0])
-         {
-            if (g.HoveredRootWindow != NULL)
-            {
-               // Set ActiveId even if the _NoMove flag is set, without it dragging away from a window with _NoMove would activate hover on other windows.
-               FocusWindow(g.HoveredWindow);
-               SetActiveID(g.HoveredWindow->MoveId, g.HoveredWindow);
-               g.NavDisableHighlight = true;
-               g.ActiveIdClickOffset = g.IO.MousePos - g.HoveredRootWindow->Pos;
-               if (!(g.HoveredWindow->Flags & ImGuiWindowFlags_NoMove) && !(g.HoveredRootWindow->Flags & ImGuiWindowFlags_NoMove))
-                  g.MovingWindow = g.HoveredWindow;
-            }
-            else if (g.NavWindow != NULL && GetFrontMostPopupModal() == NULL)
-            {
-               // Clicking on void disable focus
-               FocusWindow(NULL);
-            }
-         }
-
-         // With right mouse button we close popups without changing focus
-         // (The left mouse button path calls FocusWindow which will lead NewFrame->ClosePopupsOverWindow to trigger)
-         if (g.IO.MouseClicked[1])
-         {
-            // Find the top-most window between HoveredWindow and the front most Modal Window.
-            // This is where we can trim the popup stack.
-            ImGuiWindow* modal = GetFrontMostPopupModal();
-            bool hovered_window_above_modal = false;
-            if (modal == NULL)
-               hovered_window_above_modal = true;
-            for (int i = g.Windows.Size - 1; i >= 0 && hovered_window_above_modal == false; i--)
-            {
-               ImGuiWindow* window = g.Windows[i];
-               if (window == modal)
-                  break;
-               if (window == g.HoveredWindow)
-                  hovered_window_above_modal = true;
-            }
-            ClosePopupsOverWindow(hovered_window_above_modal ? g.HoveredWindow : modal);
-         }
-      }
-   }
-
-   // Sort the window list so that all child windows are after their parent
-   // We cannot do that on FocusWindow() because childs may not exist yet
-   g.WindowsSortBuffer.resize(0);
-   g.WindowsSortBuffer.reserve(g.Windows.Size);
-   for (int i = 0; i != g.Windows.Size; i++)
-   {
-      ImGuiWindow* window = g.Windows[i];
-      if (window->Active && (window->Flags & ImGuiWindowFlags_ChildWindow))       // if a child is active its parent will add it
-         continue;
-      AddWindowToSortedBuffer(&g.WindowsSortBuffer, window);
-   }
-
-   IM_ASSERT(g.Windows.Size == g.WindowsSortBuffer.Size);  // we done something wrong
-   g.Windows.swap(g.WindowsSortBuffer);
-
-   // Clear Input data for next frame
-   g.IO.MouseWheel = g.IO.MouseWheelH = 0.0f;
-   memset(g.IO.InputCharacters, 0, sizeof(g.IO.InputCharacters));
-   memset(g.IO.NavInputs, 0, sizeof(g.IO.NavInputs));
-
-   g.FrameCountEnded = g.FrameCount;
+    ImGuiContext& g = *GImGui;
+    IM_ASSERT(g.Initialized);
+
+    // Don't process EndFrame() multiple times.
+    if (g.FrameCountEnded == g.FrameCount)
+        return;
+    IM_ASSERT(g.WithinFrameScope && "Forgot to call ImGui::NewFrame()?");
+
+    ErrorCheckEndFrameSanityChecks();
+
+    // Notify OS when our Input Method Editor cursor has moved (e.g. CJK inputs using Microsoft IME)
+    if (g.IO.ImeSetInputScreenPosFn && (g.PlatformImeLastPos.x == FLT_MAX || ImLengthSqr(g.PlatformImeLastPos - g.PlatformImePos) > 0.0001f))
+    {
+        g.IO.ImeSetInputScreenPosFn((int)g.PlatformImePos.x, (int)g.PlatformImePos.y);
+        g.PlatformImeLastPos = g.PlatformImePos;
+    }
+
+    // Hide implicit/fallback "Debug" window if it hasn't been used
+    g.WithinFrameScopeWithImplicitWindow = false;
+    if (g.CurrentWindow && !g.CurrentWindow->WriteAccessed)
+        g.CurrentWindow->Active = false;
+    End();
+
+    // Update navigation: CTRL+Tab, wrap-around requests
+    NavEndFrame();
+
+    // Drag and Drop: Elapse payload (if delivered, or if source stops being submitted)
+    if (g.DragDropActive)
+    {
+        bool is_delivered = g.DragDropPayload.Delivery;
+        bool is_elapsed = (g.DragDropPayload.DataFrameCount + 1 < g.FrameCount) && ((g.DragDropSourceFlags & ImGuiDragDropFlags_SourceAutoExpirePayload) || !IsMouseDown(g.DragDropMouseButton));
+        if (is_delivered || is_elapsed)
+            ClearDragDrop();
+    }
+
+    // Drag and Drop: Fallback for source tooltip. This is not ideal but better than nothing.
+    if (g.DragDropActive && g.DragDropSourceFrameCount < g.FrameCount && !(g.DragDropSourceFlags & ImGuiDragDropFlags_SourceNoPreviewTooltip))
+    {
+        g.DragDropWithinSource = true;
+        SetTooltip("...");
+        g.DragDropWithinSource = false;
+    }
+
+    // End frame
+    g.WithinFrameScope = false;
+    g.FrameCountEnded = g.FrameCount;
+
+    // Initiate moving window + handle left-click and right-click focus
+    UpdateMouseMovingWindowEndFrame();
+
+    // Sort the window list so that all child windows are after their parent
+    // We cannot do that on FocusWindow() because children may not exist yet
+    g.WindowsTempSortBuffer.resize(0);
+    g.WindowsTempSortBuffer.reserve(g.Windows.Size);
+    for (int i = 0; i != g.Windows.Size; i++)
+    {
+        ImGuiWindow* window = g.Windows[i];
+        if (window->Active && (window->Flags & ImGuiWindowFlags_ChildWindow))       // if a child is active its parent will add it
+            continue;
+        AddWindowToSortBuffer(&g.WindowsTempSortBuffer, window);
+    }
+
+    // This usually assert if there is a mismatch between the ImGuiWindowFlags_ChildWindow / ParentWindow values and DC.ChildWindows[] in parents, aka we've done something wrong.
+    IM_ASSERT(g.Windows.Size == g.WindowsTempSortBuffer.Size);
+    g.Windows.swap(g.WindowsTempSortBuffer);
+    g.IO.MetricsActiveWindows = g.WindowsActiveCount;
+
+    // Unlock font atlas
+    g.IO.Fonts->Locked = false;
+
+    // Clear Input data for next frame
+    g.IO.MouseWheel = g.IO.MouseWheelH = 0.0f;
+    g.IO.InputQueueCharacters.resize(0);
+    memset(g.IO.NavInputs, 0, sizeof(g.IO.NavInputs));
 }
 
 void ImGui::Render()
 {
-   ImGuiContext& g = *GImGui;
-   IM_ASSERT(g.Initialized);   // Forgot to call ImGui::NewFrame()
-
-   if (g.FrameCountEnded != g.FrameCount)
-      ImGui::EndFrame();
-   g.FrameCountRendered = g.FrameCount;
-
-   // Gather windows to render
-   g.IO.MetricsRenderVertices = g.IO.MetricsRenderIndices = g.IO.MetricsActiveWindows = 0;
-   g.DrawDataBuilder.Clear();
-   ImGuiWindow* window_to_render_front_most = (g.NavWindowingTarget && !(g.NavWindowingTarget->Flags & ImGuiWindowFlags_NoBringToFrontOnFocus)) ? g.NavWindowingTarget : NULL;
-   for (int n = 0; n != g.Windows.Size; n++)
-   {
-      ImGuiWindow* window = g.Windows[n];
-      if (window->Active && window->HiddenFrames == 0 && (window->Flags & ImGuiWindowFlags_ChildWindow) == 0 && window != window_to_render_front_most)
-         AddWindowToDrawDataSelectLayer(window);
-   }
-   if (window_to_render_front_most && window_to_render_front_most->Active && window_to_render_front_most->HiddenFrames == 0) // NavWindowingTarget is always temporarily displayed as the front-most window
-      AddWindowToDrawDataSelectLayer(window_to_render_front_most);
-   g.DrawDataBuilder.FlattenIntoSingleLayer();
-
-   // Draw software mouse cursor if requested
-   ImVec2 offset, size, uv[4];
-   if (g.IO.MouseDrawCursor && g.IO.Fonts->GetMouseCursorTexData(g.MouseCursor, &offset, &size, &uv[0], &uv[2]))
-   {
-      const ImVec2 pos = g.IO.MousePos - offset;
-      const ImTextureID tex_id = g.IO.Fonts->TexID;
-      const float sc = g.Style.MouseCursorScale;
-      g.OverlayDrawList.PushTextureID(tex_id);
-      g.OverlayDrawList.AddImage(tex_id, pos + ImVec2(1, 0)*sc, pos + ImVec2(1, 0)*sc + size * sc, uv[2], uv[3], IM_COL32(0, 0, 0, 48));        // Shadow
-      g.OverlayDrawList.AddImage(tex_id, pos + ImVec2(2, 0)*sc, pos + ImVec2(2, 0)*sc + size * sc, uv[2], uv[3], IM_COL32(0, 0, 0, 48));        // Shadow
-      g.OverlayDrawList.AddImage(tex_id, pos, pos + size * sc, uv[2], uv[3], IM_COL32(0, 0, 0, 255));       // Black border
-      g.OverlayDrawList.AddImage(tex_id, pos, pos + size * sc, uv[0], uv[1], IM_COL32(255, 255, 255, 255)); // White fill
-      g.OverlayDrawList.PopTextureID();
-   }
-   if (!g.OverlayDrawList.VtxBuffer.empty())
-      AddDrawListToDrawData(&g.DrawDataBuilder.Layers[0], &g.OverlayDrawList);
-
-   // Setup ImDrawData structure for end-user
-   SetupDrawData(&g.DrawDataBuilder.Layers[0], &g.DrawData);
-   g.IO.MetricsRenderVertices = g.DrawData.TotalVtxCount;
-   g.IO.MetricsRenderIndices = g.DrawData.TotalIdxCount;
-
-   // Render. If user hasn't set a callback then they may retrieve the draw data via GetDrawData()
+    ImGuiContext& g = *GImGui;
+    IM_ASSERT(g.Initialized);
+
+    if (g.FrameCountEnded != g.FrameCount)
+        EndFrame();
+    g.FrameCountRendered = g.FrameCount;
+    g.IO.MetricsRenderWindows = 0;
+    g.DrawDataBuilder.Clear();
+
+    // Add background ImDrawList
+    if (!g.BackgroundDrawList.VtxBuffer.empty())
+        AddDrawListToDrawData(&g.DrawDataBuilder.Layers[0], &g.BackgroundDrawList);
+
+    // Add ImDrawList to render
+    ImGuiWindow* windows_to_render_top_most[2];
+    windows_to_render_top_most[0] = (g.NavWindowingTarget && !(g.NavWindowingTarget->Flags & ImGuiWindowFlags_NoBringToFrontOnFocus)) ? g.NavWindowingTarget->RootWindow : NULL;
+    windows_to_render_top_most[1] = (g.NavWindowingTarget ? g.NavWindowingListWindow : NULL);
+    for (int n = 0; n != g.Windows.Size; n++)
+    {
+        ImGuiWindow* window = g.Windows[n];
+        if (IsWindowActiveAndVisible(window) && (window->Flags & ImGuiWindowFlags_ChildWindow) == 0 && window != windows_to_render_top_most[0] && window != windows_to_render_top_most[1])
+            AddRootWindowToDrawData(window);
+    }
+    for (int n = 0; n < IM_ARRAYSIZE(windows_to_render_top_most); n++)
+        if (windows_to_render_top_most[n] && IsWindowActiveAndVisible(windows_to_render_top_most[n])) // NavWindowingTarget is always temporarily displayed as the top-most window
+            AddRootWindowToDrawData(windows_to_render_top_most[n]);
+    g.DrawDataBuilder.FlattenIntoSingleLayer();
+
+    // Draw software mouse cursor if requested
+    if (g.IO.MouseDrawCursor)
+        RenderMouseCursor(&g.ForegroundDrawList, g.IO.MousePos, g.Style.MouseCursorScale, g.MouseCursor, IM_COL32_WHITE, IM_COL32_BLACK, IM_COL32(0, 0, 0, 48));
+
+    // Add foreground ImDrawList
+    if (!g.ForegroundDrawList.VtxBuffer.empty())
+        AddDrawListToDrawData(&g.DrawDataBuilder.Layers[0], &g.ForegroundDrawList);
+
+    // Setup ImDrawData structure for end-user
+    SetupDrawData(&g.DrawDataBuilder.Layers[0], &g.DrawData);
+    g.IO.MetricsRenderVertices = g.DrawData.TotalVtxCount;
+    g.IO.MetricsRenderIndices = g.DrawData.TotalIdxCount;
+
+    // (Legacy) Call the Render callback function. The current prefer way is to let the user retrieve GetDrawData() and call the render function themselves.
 #ifndef IMGUI_DISABLE_OBSOLETE_FUNCTIONS
-   if (g.DrawData.CmdListsCount > 0 && g.IO.RenderDrawListsFn != NULL)
-      g.IO.RenderDrawListsFn(&g.DrawData);
+    if (g.DrawData.CmdListsCount > 0 && g.IO.RenderDrawListsFn != NULL)
+        g.IO.RenderDrawListsFn(&g.DrawData);
 #endif
 }
 
-const char* ImGui::FindRenderedTextEnd(const char* text, const char* text_end)
-{
-   const char* text_display_end = text;
-   if (!text_end)
-      text_end = (const char*)-1;
-
-   while (text_display_end < text_end && *text_display_end != '\0' && (text_display_end[0] != '#' || text_display_end[1] != '#'))
-      text_display_end++;
-   return text_display_end;
-}
-
-// Pass text data straight to log (without being displayed)
-void ImGui::LogText(const char* fmt, ...)
-{
-   ImGuiContext& g = *GImGui;
-   if (!g.LogEnabled)
-      return;
-
-   va_list args;
-   va_start(args, fmt);
-   if (g.LogFile)
-      vfprintf(g.LogFile, fmt, args);
-   else
-      g.LogClipboard->appendfv(fmt, args);
-   va_end(args);
-}
-
-// Internal version that takes a position to decide on newline placement and pad items according to their depth.
-// We split text into individual lines to add current tree level padding
-static void LogRenderedText(const ImVec2* ref_pos, const char* text, const char* text_end = NULL)
-{
-   ImGuiContext& g = *GImGui;
-   ImGuiWindow* window = g.CurrentWindow;
-
-   if (!text_end)
-      text_end = ImGui::FindRenderedTextEnd(text, text_end);
-
-   const bool log_new_line = ref_pos && (ref_pos->y > window->DC.LogLinePosY + 1);
-   if (ref_pos)
-      window->DC.LogLinePosY = ref_pos->y;
-
-   const char* text_remaining = text;
-   if (g.LogStartDepth > window->DC.TreeDepth)  // Re-adjust padding if we have popped out of our starting depth
-      g.LogStartDepth = window->DC.TreeDepth;
-   const int tree_depth = (window->DC.TreeDepth - g.LogStartDepth);
-   for (;;)
-   {
-      // Split the string. Each new line (after a '\n') is followed by spacing corresponding to the current depth of our log entry.
-      const char* line_end = text_remaining;
-      while (line_end < text_end)
-         if (*line_end == '\n')
+// Calculate text size. Text can be multi-line. Optionally ignore text after a ## marker.
+// CalcTextSize("") should return ImVec2(0.0f, g.FontSize)
+ImVec2 ImGui::CalcTextSize(const char* text, const char* text_end, bool hide_text_after_double_hash, float wrap_width)
+{
+    ImGuiContext& g = *GImGui;
+
+    const char* text_display_end;
+    if (hide_text_after_double_hash)
+        text_display_end = FindRenderedTextEnd(text, text_end);      // Hide anything after a '##' string
+    else
+        text_display_end = text_end;
+
+    ImFont* font = g.Font;
+    const float font_size = g.FontSize;
+    if (text == text_display_end)
+        return ImVec2(0.0f, font_size);
+    ImVec2 text_size = font->CalcTextSizeA(font_size, FLT_MAX, wrap_width, text, text_display_end, NULL);
+
+    // Round
+    text_size.x = IM_FLOOR(text_size.x + 0.95f);
+
+    return text_size;
+}
+
+// Find window given position, search front-to-back
+// FIXME: Note that we have an inconsequential lag here: OuterRectClipped is updated in Begin(), so windows moved programmatically
+// with SetWindowPos() and not SetNextWindowPos() will have that rectangle lagging by a frame at the time FindHoveredWindow() is
+// called, aka before the next Begin(). Moving window isn't affected.
+static void FindHoveredWindow()
+{
+    ImGuiContext& g = *GImGui;
+
+    ImGuiWindow* hovered_window = NULL;
+    ImGuiWindow* hovered_window_ignoring_moving_window = NULL;
+    if (g.MovingWindow && !(g.MovingWindow->Flags & ImGuiWindowFlags_NoMouseInputs))
+        hovered_window = g.MovingWindow;
+
+    ImVec2 padding_regular = g.Style.TouchExtraPadding;
+    ImVec2 padding_for_resize_from_edges = g.IO.ConfigWindowsResizeFromEdges ? ImMax(g.Style.TouchExtraPadding, ImVec2(WINDOWS_RESIZE_FROM_EDGES_HALF_THICKNESS, WINDOWS_RESIZE_FROM_EDGES_HALF_THICKNESS)) : padding_regular;
+    for (int i = g.Windows.Size - 1; i >= 0; i--)
+    {
+        ImGuiWindow* window = g.Windows[i];
+        if (!window->Active || window->Hidden)
+            continue;
+        if (window->Flags & ImGuiWindowFlags_NoMouseInputs)
+            continue;
+
+        // Using the clipped AABB, a child window will typically be clipped by its parent (not always)
+        ImRect bb(window->OuterRectClipped);
+        if (window->Flags & (ImGuiWindowFlags_ChildWindow | ImGuiWindowFlags_NoResize | ImGuiWindowFlags_AlwaysAutoResize))
+            bb.Expand(padding_regular);
+        else
+            bb.Expand(padding_for_resize_from_edges);
+        if (!bb.Contains(g.IO.MousePos))
+            continue;
+
+        // Support for one rectangular hole in any given window
+        // FIXME: Consider generalizing hit-testing override (with more generic data, callback, etc.) (#1512)
+        if (window->HitTestHoleSize.x != 0)
+        {
+            ImVec2 hole_pos(window->Pos.x + (float)window->HitTestHoleOffset.x, window->Pos.y + (float)window->HitTestHoleOffset.y);
+            ImVec2 hole_size((float)window->HitTestHoleSize.x, (float)window->HitTestHoleSize.y);
+            if (ImRect(hole_pos, hole_pos + hole_size).Contains(g.IO.MousePos))
+                continue;
+        }
+
+        if (hovered_window == NULL)
+            hovered_window = window;
+        if (hovered_window_ignoring_moving_window == NULL && (!g.MovingWindow || window->RootWindow != g.MovingWindow->RootWindow))
+            hovered_window_ignoring_moving_window = window;
+        if (hovered_window && hovered_window_ignoring_moving_window)
             break;
-         else
-            line_end++;
-      if (line_end >= text_end)
-         line_end = NULL;
-
-      const bool is_first_line = (text == text_remaining);
-      bool is_last_line = false;
-      if (line_end == NULL)
-      {
-         is_last_line = true;
-         line_end = text_end;
-      }
-      if (line_end != NULL && !(is_last_line && (line_end - text_remaining) == 0))
-      {
-         const int char_count = (int)(line_end - text_remaining);
-         if (log_new_line || !is_first_line)
-            ImGui::LogText(IM_NEWLINE "%*s%.*s", tree_depth * 4, "", char_count, text_remaining);
-         else
-            ImGui::LogText(" %.*s", char_count, text_remaining);
-      }
-
-      if (is_last_line)
-         break;
-      text_remaining = line_end + 1;
-   }
-}
-
-// Internal ImGui functions to render text
-// RenderText***() functions calls ImDrawList::AddText() calls ImBitmapFont::RenderText()
-void ImGui::RenderText(ImVec2 pos, const char* text, const char* text_end, bool hide_text_after_hash)
-{
-   ImGuiContext& g = *GImGui;
-   ImGuiWindow* window = g.CurrentWindow;
-
-   // Hide anything after a '##' string
-   const char* text_display_end;
-   if (hide_text_after_hash)
-   {
-      text_display_end = FindRenderedTextEnd(text, text_end);
-   }
-   else
-   {
-      if (!text_end)
-         text_end = text + strlen(text); // FIXME-OPT
-      text_display_end = text_end;
-   }
-
-   if (text != text_display_end)
-   {
-      window->DrawList->AddText(g.Font, g.FontSize, pos, GetColorU32(ImGuiCol_Text), text, text_display_end);
-      if (g.LogEnabled)
-         LogRenderedText(&pos, text, text_display_end);
-   }
-}
-
-void ImGui::RenderTextWrapped(ImVec2 pos, const char* text, const char* text_end, float wrap_width)
-{
-   ImGuiContext& g = *GImGui;
-   ImGuiWindow* window = g.CurrentWindow;
-
-   if (!text_end)
-      text_end = text + strlen(text); // FIXME-OPT
-
-   if (text != text_end)
-   {
-      window->DrawList->AddText(g.Font, g.FontSize, pos, GetColorU32(ImGuiCol_Text), text, text_end, wrap_width);
-      if (g.LogEnabled)
-         LogRenderedText(&pos, text, text_end);
-   }
-}
-
-// Default clip_rect uses (pos_min,pos_max)
-// Handle clipping on CPU immediately (vs typically let the GPU clip the triangles that are overlapping the clipping rectangle edges)
-void ImGui::RenderTextClipped(const ImVec2& pos_min, const ImVec2& pos_max, const char* text, const char* text_end, const ImVec2* text_size_if_known, const ImVec2& align, const ImRect* clip_rect)
-{
-   // Hide anything after a '##' string
-   const char* text_display_end = FindRenderedTextEnd(text, text_end);
-   const int text_len = (int)(text_display_end - text);
-   if (text_len == 0)
-      return;
-
-   ImGuiContext& g = *GImGui;
-   ImGuiWindow* window = g.CurrentWindow;
-
-   // Perform CPU side clipping for single clipped element to avoid using scissor state
-   ImVec2 pos = pos_min;
-   const ImVec2 text_size = text_size_if_known ? *text_size_if_known : CalcTextSize(text, text_display_end, false, 0.0f);
-
-   const ImVec2* clip_min = clip_rect ? &clip_rect->Min : &pos_min;
-   const ImVec2* clip_max = clip_rect ? &clip_rect->Max : &pos_max;
-   bool need_clipping = (pos.x + text_size.x >= clip_max->x) || (pos.y + text_size.y >= clip_max->y);
-   if (clip_rect) // If we had no explicit clipping rectangle then pos==clip_min
-      need_clipping |= (pos.x < clip_min->x) || (pos.y < clip_min->y);
-
-   // Align whole block. We should defer that to the better rendering function when we'll have support for individual line alignment.
-   if (align.x > 0.0f) pos.x = ImMax(pos.x, pos.x + (pos_max.x - pos.x - text_size.x) * align.x);
-   if (align.y > 0.0f) pos.y = ImMax(pos.y, pos.y + (pos_max.y - pos.y - text_size.y) * align.y);
-
-   // Render
-   if (need_clipping)
-   {
-      ImVec4 fine_clip_rect(clip_min->x, clip_min->y, clip_max->x, clip_max->y);
-      window->DrawList->AddText(g.Font, g.FontSize, pos, GetColorU32(ImGuiCol_Text), text, text_display_end, 0.0f, &fine_clip_rect);
-   }
-   else
-   {
-      window->DrawList->AddText(g.Font, g.FontSize, pos, GetColorU32(ImGuiCol_Text), text, text_display_end, 0.0f, NULL);
-   }
-   if (g.LogEnabled)
-      LogRenderedText(&pos, text, text_display_end);
-}
-
-// Render a rectangle shaped with optional rounding and borders
-void ImGui::RenderFrame(ImVec2 p_min, ImVec2 p_max, ImU32 fill_col, bool border, float rounding)
-{
-   ImGuiContext& g = *GImGui;
-   ImGuiWindow* window = g.CurrentWindow;
-   window->DrawList->AddRectFilled(p_min, p_max, fill_col, rounding);
-   const float border_size = g.Style.FrameBorderSize;
-   if (border && border_size > 0.0f)
-   {
-      window->DrawList->AddRect(p_min + ImVec2(1, 1), p_max + ImVec2(1, 1), GetColorU32(ImGuiCol_BorderShadow), rounding, ImDrawCornerFlags_All, border_size);
-      window->DrawList->AddRect(p_min, p_max, GetColorU32(ImGuiCol_Border), rounding, ImDrawCornerFlags_All, border_size);
-   }
-}
-
-void ImGui::RenderFrameBorder(ImVec2 p_min, ImVec2 p_max, float rounding)
-{
-   ImGuiContext& g = *GImGui;
-   ImGuiWindow* window = g.CurrentWindow;
-   const float border_size = g.Style.FrameBorderSize;
-   if (border_size > 0.0f)
-   {
-      window->DrawList->AddRect(p_min + ImVec2(1, 1), p_max + ImVec2(1, 1), GetColorU32(ImGuiCol_BorderShadow), rounding, ImDrawCornerFlags_All, border_size);
-      window->DrawList->AddRect(p_min, p_max, GetColorU32(ImGuiCol_Border), rounding, ImDrawCornerFlags_All, border_size);
-   }
-}
-
-// Render a triangle to denote expanded/collapsed state
-void ImGui::RenderArrow(ImVec2 p_min, ImGuiDir dir, float scale)
-{
-   ImGuiContext& g = *GImGui;
-   ImGuiWindow* window = g.CurrentWindow;
-
-   const float h = g.FontSize * 1.00f;
-   float r = h * 0.40f * scale;
-   ImVec2 center = p_min + ImVec2(h * 0.50f, h * 0.50f * scale);
-
-   ImVec2 a, b, c;
-   switch (dir)
-   {
-   case ImGuiDir_Up:
-   case ImGuiDir_Down:
-      if (dir == ImGuiDir_Up) r = -r;
-      center.y -= r * 0.25f;
-      a = ImVec2(0, 1) * r;
-      b = ImVec2(-0.866f, -0.5f) * r;
-      c = ImVec2(+0.866f, -0.5f) * r;
-      break;
-   case ImGuiDir_Left:
-   case ImGuiDir_Right:
-      if (dir == ImGuiDir_Left) r = -r;
-      center.x -= r * 0.25f;
-      a = ImVec2(1, 0) * r;
-      b = ImVec2(-0.500f, +0.866f) * r;
-      c = ImVec2(-0.500f, -0.866f) * r;
-      break;
-   case ImGuiDir_None:
-   case ImGuiDir_COUNT:
-      IM_ASSERT(0);
-      break;
-   }
-
-   window->DrawList->AddTriangleFilled(center + a, center + b, center + c, GetColorU32(ImGuiCol_Text));
-}
-
-void ImGui::RenderBullet(ImVec2 pos)
-{
-   ImGuiContext& g = *GImGui;
-   ImGuiWindow* window = g.CurrentWindow;
-   window->DrawList->AddCircleFilled(pos, GImGui->FontSize*0.20f, GetColorU32(ImGuiCol_Text), 8);
-}
-
-void ImGui::RenderCheckMark(ImVec2 pos, ImU32 col, float sz)
-{
-   ImGuiContext& g = *GImGui;
-   ImGuiWindow* window = g.CurrentWindow;
-
-   float thickness = ImMax(sz / 5.0f, 1.0f);
-   sz -= thickness * 0.5f;
-   pos += ImVec2(thickness*0.25f, thickness*0.25f);
-
-   float third = sz / 3.0f;
-   float bx = pos.x + third;
-   float by = pos.y + sz - third * 0.5f;
-   window->DrawList->PathLineTo(ImVec2(bx - third, by - third));
-   window->DrawList->PathLineTo(ImVec2(bx, by));
-   window->DrawList->PathLineTo(ImVec2(bx + third * 2, by - third * 2));
-   window->DrawList->PathStroke(col, false, thickness);
-}
-
-void ImGui::RenderNavHighlight(const ImRect& bb, ImGuiID id, ImGuiNavHighlightFlags flags)
-{
-   ImGuiContext& g = *GImGui;
-   if (id != g.NavId)
-      return;
-   if (g.NavDisableHighlight && !(flags & ImGuiNavHighlightFlags_AlwaysDraw))
-      return;
-   ImGuiWindow* window = ImGui::GetCurrentWindow();
-   if (window->DC.NavHideHighlightOneFrame)
-      return;
-
-   float rounding = (flags & ImGuiNavHighlightFlags_NoRounding) ? 0.0f : g.Style.FrameRounding;
-   ImRect display_rect = bb;
-   display_rect.ClipWith(window->ClipRect);
-   if (flags & ImGuiNavHighlightFlags_TypeDefault)
-   {
-      const float THICKNESS = 2.0f;
-      const float DISTANCE = 3.0f + THICKNESS * 0.5f;
-      display_rect.Expand(ImVec2(DISTANCE, DISTANCE));
-      bool fully_visible = window->ClipRect.Contains(display_rect);
-      if (!fully_visible)
-         window->DrawList->PushClipRect(display_rect.Min, display_rect.Max);
-      window->DrawList->AddRect(display_rect.Min + ImVec2(THICKNESS*0.5f, THICKNESS*0.5f), display_rect.Max - ImVec2(THICKNESS*0.5f, THICKNESS*0.5f), GetColorU32(ImGuiCol_NavHighlight), rounding, ImDrawCornerFlags_All, THICKNESS);
-      if (!fully_visible)
-         window->DrawList->PopClipRect();
-   }
-   if (flags & ImGuiNavHighlightFlags_TypeThin)
-   {
-      window->DrawList->AddRect(display_rect.Min, display_rect.Max, GetColorU32(ImGuiCol_NavHighlight), rounding, ~0, 1.0f);
-   }
-}
-
-// Calculate text size. Text can be multi-line. Optionally ignore text after a ## marker.
-// CalcTextSize("") should return ImVec2(0.0f, GImGui->FontSize)
-ImVec2 ImGui::CalcTextSize(const char* text, const char* text_end, bool hide_text_after_double_hash, float wrap_width)
-{
-   ImGuiContext& g = *GImGui;
-
-   const char* text_display_end;
-   if (hide_text_after_double_hash)
-      text_display_end = FindRenderedTextEnd(text, text_end);      // Hide anything after a '##' string
-   else
-      text_display_end = text_end;
-
-   ImFont* font = g.Font;
-   const float font_size = g.FontSize;
-   if (text == text_display_end)
-      return ImVec2(0.0f, font_size);
-   ImVec2 text_size = font->CalcTextSizeA(font_size, FLT_MAX, wrap_width, text, text_display_end, NULL);
-
-   // Cancel out character spacing for the last character of a line (it is baked into glyph->AdvanceX field)
-   const float font_scale = font_size / font->FontSize;
-   const float character_spacing_x = 1.0f * font_scale;
-   if (text_size.x > 0.0f)
-      text_size.x -= character_spacing_x;
-   text_size.x = (float)(int)(text_size.x + 0.95f);
-
-   return text_size;
-}
-
-// Helper to calculate coarse clipping of large list of evenly sized items.
-// NB: Prefer using the ImGuiListClipper higher-level helper if you can! Read comments and instructions there on how those use this sort of pattern.
-// NB: 'items_count' is only used to clamp the result, if you don't know your count you can use INT_MAX
-void ImGui::CalcListClipping(int items_count, float items_height, int* out_items_display_start, int* out_items_display_end)
-{
-   ImGuiContext& g = *GImGui;
-   ImGuiWindow* window = g.CurrentWindow;
-   if (g.LogEnabled)
-   {
-      // If logging is active, do not perform any clipping
-      *out_items_display_start = 0;
-      *out_items_display_end = items_count;
-      return;
-   }
-   if (window->SkipItems)
-   {
-      *out_items_display_start = *out_items_display_end = 0;
-      return;
-   }
-
-   const ImVec2 pos = window->DC.CursorPos;
-   int start = (int)((window->ClipRect.Min.y - pos.y) / items_height);
-   int end = (int)((window->ClipRect.Max.y - pos.y) / items_height);
-   if (g.NavMoveRequest && g.NavMoveDir == ImGuiDir_Up) // When performing a navigation request, ensure we have one item extra in the direction we are moving to
-      start--;
-   if (g.NavMoveRequest && g.NavMoveDir == ImGuiDir_Down)
-      end++;
-
-   start = ImClamp(start, 0, items_count);
-   end = ImClamp(end + 1, start, items_count);
-   *out_items_display_start = start;
-   *out_items_display_end = end;
-}
-
-// Find window given position, search front-to-back
-// FIXME: Note that we have a lag here because WindowRectClipped is updated in Begin() so windows moved by user via SetWindowPos() and not SetNextWindowPos() will have that rectangle lagging by a frame at the time FindHoveredWindow() is called, aka before the next Begin(). Moving window thankfully isn't affected.
-static ImGuiWindow* FindHoveredWindow()
-{
-   ImGuiContext& g = *GImGui;
-   for (int i = g.Windows.Size - 1; i >= 0; i--)
-   {
-      ImGuiWindow* window = g.Windows[i];
-      if (!window->Active)
-         continue;
-      if (window->Flags & ImGuiWindowFlags_NoInputs)
-         continue;
-
-      // Using the clipped AABB, a child window will typically be clipped by its parent (not always)
-      ImRect bb(window->WindowRectClipped.Min - g.Style.TouchExtraPadding, window->WindowRectClipped.Max + g.Style.TouchExtraPadding);
-      if (bb.Contains(g.IO.MousePos))
-         return window;
-   }
-   return NULL;
+    }
+
+    g.HoveredWindow = hovered_window;
+    g.HoveredRootWindow = g.HoveredWindow ? g.HoveredWindow->RootWindow : NULL;
+    g.HoveredWindowUnderMovingWindow = hovered_window_ignoring_moving_window;
 }
 
